using System.Text;

namespace Web.JavaScript
{
    public class JSUtilities
    {
        public static string EncodeString(string unencodedString)
        {
            StringBuilder builder = new StringBuilder();
            foreach(char chr in unencodedString)
            {
                switch (chr)
                {
                    case (char)39:
                        builder.Append("\\\'");
                        break;
                    case '\"':
                        builder.Append("\\\"");
                        break;
                    case '\\':
                        builder.Append("\\\\");
                        break;
                    case '\b':
                        builder.Append("\\b");
                        break;
                    case '\f':
                        builder.Append("\\f");
                        break;
                    case '\n':
                        builder.Append("\\n");
                        break;
                    case '\r':
                        builder.Append("\\r");
                        break;
                    case '\t':
                        builder.Append("\\t");
                        break;
                    default:
                        int i = (int)chr;
                        if (i < 32 || i > 127)
                        {
                            builder.AppendFormat("\\u{0:X04}", i);
                        }
                        else
                        {
                            builder.Append(chr);
                        }
                        break;
                }
            }
            return builder.ToString();
        }
    }
}
