using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;
using System.Globalization;
using System.Threading;

namespace SettingTheCultureInTheURL
{
    public class Global : System.Web.HttpApplication
    {

        protected void Application_Start(object sender, EventArgs e)
        {

        }

        protected void Application_End(object sender, EventArgs e)
        {

        }
        void Application_BeginRequest(object sender, EventArgs e)
        {
            CultureInfo cultureInfo = GetCultureFromUrl(Request.Url);
            if (cultureInfo != null)
            {
                Thread.CurrentThread.CurrentUICulture = cultureInfo;
                Thread.CurrentThread.CurrentCulture = 
                    CultureInfo.CreateSpecificCulture(cultureInfo.Name);
                // strip the culture name from the front of the path
                Context.RewritePath(Request.Url.LocalPath.
                    Substring(cultureInfo.Name.Length + 1));
            }
        }

        private CultureInfo GetCultureFromUrl(Uri uri)
        {
            string uriCultureName = uri.LocalPath.Substring(1);
            int uriIndex = uriCultureName.IndexOf('/');

            if (uriIndex == -1)
                // the path has no further path delimiters
                // so it cannot contain a culture
                return null;

            uriCultureName = uriCultureName.Substring(0, uriIndex);

            foreach (CultureInfo cultureInfo in
                CultureInfo.GetCultures(CultureTypes.AllCultures))
            {
                if (String.Compare(uriCultureName, cultureInfo.Name,
                    StringComparison.OrdinalIgnoreCase) == 0)
                    // the URI matches a culture name
                    return cultureInfo;
            }
            return null;
        }

    }
}